	var isProgressPopupAllowed = true;
	var isUnpackPopupAllowed = false;
	var inConnectionFlow = false;
	var dlProgressBarId = 'dlpb';
	var lang = "en";
	var inCheckConnection = false;
	var isQueueRetrieved = false;
	var connectionTypeMsg = ""
	//var using3g = false;
	var packagesDownloaded = 0;
	var autoCloseTimer = null;
	var currentProgress = 0;
	var downloadRequest = null;
	var packageProgress = false;
	var downloadedPackages = []; //packages from queue, not finished
	var isCancelDialog = false;
	var connectionChanged = false;
	var isProcessingScreen = false;
	var doPopupNumber = 0;
	var showOtherPopUp = 0;
	var savedTitle;
	var savedMessage;
	var savedButtons;
	var isInitialized = false;
	
	String.prototype.format = function() 
	{
		var formatted = this;
		for (var arg = 0; arg < arguments.length; arg++)
		{
			formatted = formatted.replace("{" + arg + "}", arguments[arg]);
		}
		return formatted;
	};
	

	var counter = 0;
	function adclog(message) {
		setTimeout(function() {
			ADC.log("" + (counter++) + " : " + message);
		}, 250);
	}
	
	function setInConnectionFlow(icf)
	{
		adclog("setInConnectionFlow("+icf+")");
		inConnectionFlow = icf;
	}
	
	function onMessage(msg)
	{
		//adclog("onMessage." + JSON.stringify(msg)); //- spams
		
		var title, message, buttonText, buttonText2;
		
		if(msg.type == MSG_TYPE.UPDATES_RETRIEVED())
		{
			adclog("onMessage() - UPDATES_RETRIEVED");
			if(autoCloseTimer!=null)
			{
				clearInterval(autoCloseTimer);
				autoCloseTimer = null;
			}
			
			getUpdatesCallback( msg.package );
		}
        else if (msg.type == MSG_TYPE.PACKAGE_PROGRESS()) 
        {
            if (doPopupNumber == 1)
                doPopupWithProgressBar(false);
			packageProgress = true;		
			updateProgressCallback( msg.progress );
		}
		else if(msg.type == MSG_TYPE.PACKAGE_FINISHED())
		{	
			adclog("onMessage() - PACKAGE_FINISHED");
			downloadFinishedCallback( msg.package );
		}
		else if(msg.type == MSG_TYPE.QUEUE_RETRIEVED())
		{
			adclog("onMessage() - QUEUE_RETRIEVED");
			getQueueCallback( msg.package );
		}
		else if(msg.type == MSG_TYPE.ERROR())
		{
			adclog("onMessage() - ERROR "+msg.error[0].code);
			title = adcStrings[lang].ERROR,
			message = '',
			buttonText = adcStrings[lang].OK;
				
			//Handle some errors
			/*if(msg.error[0].code == ERROR_CODE.ASSET_NOT_AVAILABLE())
			{
				message = adcStrings[lang].DOWNLOAD_FAILED + msg.error[0].code+" (ASSET_NOT_AVAILABLE)";
				doPopup(title, message, [
					{ text: buttonText, callback: function(){
						checkConnection(doPopupWithProgressBar);
					} }
				]);
			}
			else */
			if(msg.error[0].code == ERROR_CODE.CHECKSUM_MISMATCH())
			{
				message = adcStrings[lang].DOWNLOAD_FAILED + msg.error[0].code+" (CHECKSUM_MISMATCH)";
				//do not show this error as it's not stopping the download
			}
			else if(msg.error[0].code == ERROR_CODE.INSUFFICIENT_SPACE())
			{
				message = adcStrings[lang].INSUFFICIENT_SPACE;
				doPopup(title, message, [
					{ text: buttonText, callback: function(){
						ADC.close();
						ADC.onCancelUI(false);						
					} }
				]);
			}
			else if(msg.error[0].code == ERROR_CODE.ASSET_ALREADY_IN_QUEUE())
			{
				message = adcStrings[lang].DOWNLOAD_FAILED + msg.error[0].code;
				//do not show this error as it's not stopping the download
			}
			else
			{
				message = adcStrings[lang].DOWNLOAD_FAILED + msg.error[0].code;
				doPopup(title, message, [
					{ text: buttonText, callback: function(){
						ADC.close();
						ADC.onUIFinished(msg.error[0].code, msg.packId);						
					} }
				]);
			}
		}
		else if(msg.type == MSG_TYPE.CONNECTION_CHANGE())
		{
			adclog("onMessage() - CONNECTION_CHANGE "+msg.connection[0].type);
			
			if(isProgressPopupAllowed==true)
			{
				if( inCheckConnection==false || msg.connection[0].type== CONNECTION_TYPE.WIFI_CONNECTION()
				|| msg.connection[0].type== CONNECTION_TYPE.CONNECTION_3G())
				{					
					connectionChanged = true;
					checkConnection(doPopupWithProgressBar);
				}
			}
			else
				ADC.getPackages();
		}
		else if(msg.type == MSG_TYPE.DOWNLOAD_REQUEST())
		{
			adclog("onMessage() - DOWNLOAD_REQUEST");
			ADC.getQueue();
			if(autoCloseTimer!=null)
			{
				clearInterval(autoCloseTimer);
				autoCloseTimer = null;
			}
			downloadRequest = msg.data;
			downloadRequestCallback( msg.data );
		}
		else if(msg.type == MSG_TYPE.CANCEL_REQUEST())
		{
			adclog("onMessage() - CANCEL_REQUEST");
			if (inConnectionFlow == false) 
            {
                // close ui if back was tapped while on the confirmation screen
                if (isUnpackPopupAllowed == false && isProgressPopupAllowed == false) 
                {
					ADC.close();
                    ADC.onCancelUI(false);
                }
                else 
                {
                    if (isCancelDialog)
                        closeCancelDialog(!packageProgress);
                    else
					{	
						ADC.onCancelUI(true);
						ADC.runInBackground();
					}
                }
			}
		}
		else if(msg.type == MSG_TYPE.UNPACK())
		{
			adclog("onMessage() - UNPACK");
			isUnpackPopupAllowed = true;
			isProgressPopupAllowed = false;
			doPopupWithLoader();
		}
		else if(msg.type == MSG_TYPE.ON_UI_DISPLAY())
		{
			adclog("onMessage() - ON_UI_DISPLAY");
			inCheckConnection=false
			isQueueRetrieved = false;
			
			// Javascript may not get UNPACK message(running in background for example), so check Java side to see if is unpacking
			if(ADC.isUnpacking())
			{
				isUnpackPopupAllowed = true;
				isProgressPopupAllowed = false;
            }

            adclog("onMessage() - ON_UI_DISPLAY isCancelDialog " + isCancelDialog);
            // check if the screen had previously cancel dialog
            if (isCancelDialog)
			{
				adclog("onMessage() - ON_UI_DISPLAY doCancelDialog");
                doCancelDialog(!packageProgress);
			}
            else if(isProcessingScreen == false)
            {
                if (isProgressPopupAllowed == true) 
                {
                    var title = adcStrings[lang].DOWNLOADING;
                    var active = 0;
                    for (var p in $.downloadRequests.getAllInfo()) {
                        active++;
                    }
                    //title = title +" ["+packagesDownloaded+"/"+active+"]";
					if(!isCancelDialog) $("#dialog").dialog("option", "title", title);

                    //autoCloseTimer = setTimeout( function(){ ADC.close()}, 2000);
                    ADC.getQueue();
                    checkConnection(doPopupWithProgressBar);
                }
                else if (isUnpackPopupAllowed) 
                {
                    doPopupWithLoader();
                }
                else if(!isInitialized)
                {
                    adclog("onMessage() - ON_UI_DISPLAY call download request");
                    checkConnection(doInitPopup);
                    downloadRequestCallback(downloadRequest);
                }
            }
		}
		else if(msg.type == MSG_TYPE.PACKAGE_CANCELLED())
		{	
			adclog("onMessage() - PACKAGE_CANCELLED");
			ADC.close();
			ADC.requestApplicationClose();			
		}
		else if(msg.type == MSG_TYPE.PACKAGE_PAUSED())
		{	
			adclog("onMessage() - PACKAGE_PAUSED");
			ADC.close();
			ADC.requestApplicationClose();			
		}
		else if(msg.type == MSG_TYPE.PROCESSING_SCREEN())
		{
			adclog("onMessage() - PROCESSING_SCREEN");
			isProcessingScreen = true;
			doProcessingScreen();
		}
		else if(msg.type == MSG_TYPE.STOP_PROCESSING_SCREEN())
		{
			adclog("onMessage() - STOP_PROCESSING_SCREEN");	
			if (isProgressPopupAllowed == true)
			{
				isProcessingScreen = false;
				var title = adcStrings[lang].DOWNLOADING;
				var active = 0;
				for (var p in $.downloadRequests.getAllInfo()) {
					active++;
                }
				if(!isCancelDialog) $("#dialog").dialog("option", "title", title);
				ADC.getQueue();
				checkConnection(doPopupWithProgressBar);
			}
		}
		else
		{
			adclog("onMessage() - UNKNOWN MESSAGE!!!");
			//addLine(".: Unknown message: "+msg.type);
			//addLine(JSON.stringify(msg));
		}
	}
	

	$.downloadRequests = {
		/**
		 * should contain objects of all requests that should be downloaded,
		 * later objects may contain some aditional info from updates request
		 * callback
		 */
		requests : [],
		/**
		 * this list of object is used to display info about status
		 * of downloading in progress bar. So download requests + currently
		 * downloaded assets
		 */
		requestsInfo : [],
		set : function( requests )
		{
			this.requests = requests;
		},
		addMany : function( requests )
		{
			for( var requestIndex in requests )
			{
				var request = requests[requestIndex];
				if( !this.get( request.id) )
				{
					this.add( request );
				}
			}
		},
		add : function( request )
		{
			this.requests.push( request );
		},
		get : function( requestId )
		{
			var searchedRequest = null;
			for(var requestIndex in this.requests )
			{
				var request = this.requests[requestIndex];
				if( request.id == requestId )
				{
					searchedRequest = request;
					searchedRequest.indexInArray = requestIndex;
					break;
				}
			}
			return searchedRequest;
		},
		getAllRequests : function()
		{
			return this.requests;
		},
		updateMany : function( newRequestDataSet )
		{
			var updated = [];
			for( var requestDataIndex in newRequestDataSet )
			{
				var newRequestData = newRequestDataSet[requestDataIndex];
				var update = this.update( newRequestData );
				if( update )
					updated.push( update );
			}
			return updated;
		},
		update : function( newRequestData )
		{
			var request = this.get( newRequestData.id );
			if( request )
			{
				if( request.status != 6 )
				{
					var savedPriority = this.requests[request.indexInArray].priority;
					if(savedPriority != 0) 
						newRequestData.priority = savedPriority;
					return this.requests[request.indexInArray] = newRequestData;
				}
			}
			return null;
		},
		updateInfoMany : function( newRequestInfoData )
		{
			for( var requestDataIndex in newRequestInfoData )
			{
				var pickedData = newRequestInfoData[requestDataIndex];
				this.updateInfo( pickedData );
			}
		},
		updateInfo : function( newRequestInfoData )
		{
			this.requestsInfo[newRequestInfoData.id] = newRequestInfoData;
		},
		getInfo : function( requestId )
		{
			return this.requestsInfo[requestId] || null;
		},
		getAllInfo : function()
		{
			return this.requestsInfo;
		},
		updateProperty : function( requestId, propertyName, propertyValue )
		{
			var request = this.get( requestId );
			if( request )
			{
				request[propertyName] = propertyValue;
			}
			
			var requestInfo = this.getInfo( requestId );
			if( requestInfo )
			{
				requestInfo[propertyName] = propertyValue;
			}
		},
		remove : function( requestId )
		{
			var request = this.get( requestId )
			if( request )
				this.requests.splice( request.indexInArray, 1 );
		},
		removeAll : function()
		{
			this.requests = [];
		},
		checkIfAllDownloaded : function()
		{
			var requests = this.getAllRequests(),
			isAllDownloaded = true;
			for( var index in requests )
			{
				var request = requests[index];
				if( request.progress != 100 )
				{
					isAllDownloaded = false;
					break;
				}
			}
			return isAllDownloaded;
		},
		checkIfNewRequests : function(newRequests)
		{
			adclog("checkIfNewRequests()");
			var requests = this.getAllRequests();
			
			// check if newRequests array empty
			if (newRequests.length == 0)
				return true;
				
			adclog("checkIfNewRequests() - newRequests size "+newRequests.length+" requests size "+requests.length);
			for( var newRequestIndex in newRequests )
			{
				adclog("checkIfNewRequests() newRequests["+newRequestIndex+"] "+newRequests[newRequestIndex].id+" "+newRequests[newRequestIndex].priority);
				var found = false;
				for( var requestIndex in requests )
				{
					adclog("checkIfNewRequests() requests["+requestIndex+"] "+requests[requestIndex].id+" "+requests[requestIndex].priority);
					if(newRequests[newRequestIndex].id == requests[requestIndex].id)
					{
						adclog("checkIfNewRequests() - found request with id "+requests[requestIndex].id);
						// if unpacking then the request found is almost finished 
						if(isUnpackPopupAllowed)
						{							
							found = true;
						}
					}				
				}
				// the new request was not found in our list of requests
				// no need to check the others
				if(!found)
				{
					return true;
				}
			}
			
			return false;
		}
	}

	/**
	 * Gets information requred for popup inside assetsFlow
	 */
	function getPackagesSummarizedInfo( packages )
	{
		adclog("getPackagesSummarizedInfo()");
		var packsNameLenght = 0;
		var displayName = ADC.getUiDisplayName();
		
		var info = {
			totalSize : 0,
			totalUncompressedSize : 0,
			fullName : "",
			isRequired : false
		}, names = [];
		for( var index in packages )
		{
			var pack = packages[index];
			info.totalSize += parseFloat(pack.size);
			info.totalUncompressedSize += parseFloat(pack.uncompressed);
			//skip dummy packages
			if (pack.id == 0) continue;
			
			packsNameLenght += pack.name.length + 2;			
			if (packsNameLenght < 90)
				names.push( pack.name );
			info.isRequired = pack.isRequired || info.isRequired;
		}
		
		//check if there is a display name instead of packages name
		if(!displayName || 0 == displayName.length || "" == displayName)
			info.fullName = names.join(", ");
		else
			info.fullName = displayName;
		
		//if there are too many packages don't list them
		if (packsNameLenght > 90)		
			info.fullName +=" ...";
		return info;
	}
	
	// Assets Flow -> Connectivity Flow -> Download Flow
	function assetsFlow( requestedPackages )
	{
		adclog("assetsFlow()");

		var title, message, buttonText, buttonText2,
		packagesInfo = getPackagesSummarizedInfo( requestedPackages );
		
		//setInConnectionFlow(true);
		
		var freespace = ADC.getFreeSpace("");
		//var freespaceMB = (freespace/(1024*1024)).toFixed(2);
		var size = packagesInfo.totalSize;
		var sizeMB = (size/(1024*1024)).toFixed(2);
		var sizeAfterDownload = parseFloat(freespace);
		var sizeAfterDownloadMB = (sizeAfterDownload/(1024*1024)).toFixed(2);
		var fullName = packagesInfo.fullName;		
		var msg = "";
		
		var uiUncompressedSize = ADC.getUiUncompressedSize();		
		var uncompressedSize = 0;
		if (uiUncompressedSize > 0)
			uncompressedSize = uiUncompressedSize;
		else
			uncompressedSize = packagesInfo.totalUncompressedSize;
			
		var uncompressedMB = (uncompressedSize/(1024*1024)).toFixed(2);			
		var freeSpaceNeeded = 0;
		var msgInsufficientSpace = "";
		var msg = String(ADC.getConfirmationText());		
		
		if (!msg || 0 == msg.length || "" == msg)
		{
			if (uncompressedSize > 0)
			{
				adclog("assetsFlow() MSG_DOWNLOAD_PACKAGE_WITH_UNCOMPRESSED " + uncompressedMB);
				msg = adcStrings[lang].MSG_DOWNLOAD_PACKAGE_WITH_UNCOMPRESSED.format(fullName, sizeMB,uncompressedMB);				
			}
			else
			{
				adclog("assetsFlow() MSG_DOWNLOAD_PACKAGE_WITHOUT_UNCOMPRESSED");
				msg = adcStrings[lang].MSG_DOWNLOAD_PACKAGE_WITHOUT_UNCOMPRESSED.format(fullName, sizeMB);	
			}
		}	
		
		if (uncompressedSize > 0)
		{
			msgInsufficientSpace = adcStrings[lang].MSG_INSUFFICIENT_SPACE.format(uncompressedMB);
			freeSpaceNeeded = uncompressedSize;
		}
		else
		{
			msgInsufficientSpace = adcStrings[lang].MSG_INSUFFICIENT_SPACE.format(sizeMB);
			freeSpaceNeeded = size;
		}
		
		title = adcStrings[lang].CONFIRM,
		message = msg,
		buttonText = adcStrings[lang].DOWNLOAD,
		buttonText2 = adcStrings[lang].EXIT;
		doPopup(title, message, [
			{ text: buttonText, callback : function( ){
				if(freeSpaceNeeded > freespace)
				{
					title = adcStrings[lang].ERROR,
					message = msgInsufficientSpace,
					buttonText = adcStrings[lang].OK;
					doPopup(title, message, [
						{ text: buttonText, callback: function(){
							ADC.close();
							ADC.onUIError(ERROR_CODE.INSUFFICIENT_SPACE());							
						} }
					]);
				}
				else
				{
					connectivityFlow( requestedPackages );
				}
			} },
			{ text: buttonText2, callback : function( ){
				ADC.close();
				ADC.onCancelUI(false);				
			} }
		]);
	}
	
	// Connectivity Flow -> Download Flow
	function connectivityFlow( requestedPackages )
	{
		adclog( "connectivityFlow()");
		
		setInConnectionFlow(true);
		var title, message, buttonText, buttonText2;
		if( ADC.isConnected())
		{
			adclog( "connectivityFlow() - Mercury is connected");
			connectionTypeMsg = adcStrings[lang].DOWNLOADING_OVER_WIFI;
			
			if( ADC.is3G())
			{			
				var status3GConfirm = ADC.get3GConfirmOnStartup();
				adclog( "connectivityFlow()"+status3GConfirm+connectionChanged);
				if (status3GConfirm == true || connectionChanged == true)
				{
					//if status of 3G confirmation screen is default act normal
					title = adcStrings[lang].CONFIRM;
					if(ADC.is4G())
					{
						adclog( "connectivityFlow() - 4G");
						message =  adcStrings[lang].CONTINUE_WITH_4G;
					}
					else
					{
						adclog( "connectivityFlow() - 3G");
						message = adcStrings[lang].CONTINUE_WITH_3G;
					}
					buttonText = adcStrings[lang].YES,
					buttonText2 = adcStrings[lang].NO;

					doPopup(title, message, [
						{ text: buttonText, callback: function () {
							if (ADC.is4G()) {
								connectionTypeMsg = adcStrings[lang].DOWNLOADING_OVER_4G;
							}
							else {
								connectionTypeMsg = adcStrings[lang].DOWNLOADING_OVER_3G;
							}
							//using3g = true;
							ADC.set3gAllowed(true);
							downloadFlow(requestedPackages);
						}
						},
						{ text: buttonText2, callback: function () {
							ADC.close();
							ADC.onCancelUI(false);
						}
						}
					]);
				}
				else
				{
					//if status of 3G confirmation screen is false disable appearence of 3G confirmation 
					//screen only in the case of starting new downloads														
					if (ADC.is4G()) {
						connectionTypeMsg = adcStrings[lang].DOWNLOADING_OVER_4G;
					}
					else {
						connectionTypeMsg = adcStrings[lang].DOWNLOADING_OVER_3G;
					}
					//using3g = true;
					ADC.set3gAllowed(true);
					downloadFlow(requestedPackages);					
				}
			}
			else
			{	
				//using3g = false;
				ADC.set3gAllowed(false);
				downloadFlow( requestedPackages );
			}			
		}
		else
		{
			title = adcStrings[lang].CONFIRM,
			message =  adcStrings[lang].NO_WIFI,
			buttonText = adcStrings[lang].YES,
			buttonText2 = adcStrings[lang].NO;
			doPopup(title, message, [
				{ text: buttonText, callback : function( ){
					ADC.runConnectionManagment();
					title = adcStrings[lang].ERROR,
					buttonText = adcStrings[lang].OK,
					message = adcStrings[lang].WAIT_FOR_WIFI;
					doPopup(title, message, [
						{ text: buttonText, callback: function(){
							connectivityFlow( requestedPackages );
						}}
					]);
				} },
				{ text: buttonText2, callback : function( ){
					ADC.close();
					ADC.onCancelUI(false);
				} }
			]);
		}		
		setInConnectionFlow(false);
	}
	
	// Download Flow
	function downloadFlow( requestedPackages )
	{
		adclog( "downloadFlow()");
		var downloadResumed = false;
		
		for( var index in requestedPackages )
		{
			var pack = requestedPackages[index];
			downloadResumed = false;
			adclog("downloadFlow() START - name "+pack.name+" status "+pack.status+" id "+pack.id+" priority "+pack.priority);		
			for( var i in downloadedPackages )
			{				
				adclog("downloadFlow() STOPPED - name "+downloadedPackages[i].name+" status "+ downloadedPackages[i].status+" id "+ downloadedPackages[i].id+" priority "+downloadedPackages[i].priority);
				if (pack.name == downloadedPackages[i].name &&
				pack.status == 0 && downloadedPackages[i].status == 5 &&
				pack.id == downloadedPackages[i].id)
				{
					ADC.resumeDownload(pack.id);
					downloadResumed = true;
					break;
				}
			}
			if (downloadResumed == false)
				ADC.startDownload( pack.id, pack.destPath, pack.priority );
		}
		
		isProgressPopupAllowed = true;
		doPopupWithProgressBar();
	}
	
	/**
	 * Calcutaltes summed progress and speed of whole being downloaded files
	 */
	function calculateSummedProgressAndSpeed( )
	{
		adclog("calculateSummedProgressAndSpeed()");
		
		var allRequests = $.downloadRequests.getAllInfo();
		var totalSize = 0;
		var downloadedSize = 0;
		var totalSpeed = 0;
		for( var i in allRequests )
		{
			
			var pickedRequest = allRequests[i];
			if( !pickedRequest.progress )
			{
				pickedRequest.progress = 0;
			}
			
			if( !pickedRequest.speed )
			{
				pickedRequest.speed = 0;
			}
			
			downloadedSize += pickedRequest.progress * pickedRequest.size 
			totalSize += pickedRequest.size;
			totalSpeed += parseFloat(pickedRequest.speed);
		}
		
		var progress = Math.ceil(downloadedSize / totalSize);
		totalSpeed = Math.ceil(totalSpeed * 100) / 100;
		
		/* Sometimes progress might be NaN cause we get progress update before we get updates about packages */
		if( isNaN(progress) )
		{
			progress = 0;
		}
		
		if( isNaN(totalSpeed) )
		{
			totalSpeed = 0;
		}
		
		return { progress : progress, speed : totalSpeed };
	}
	
	/**
	 * Updates progress info if progressBar popup is visable
	 */
	function updateProgressCallback( progressData )
	{		
		//adclog("updateProgressCallback"); - spams
		
		progressData = progressData[0];
		currentProgress = progressData.progress.toFixed(2);
		//if(progressData.id==0)
		//adclog(progressData.id+" Overall progress: "+progressData.progress+" speed: "+(progressData.bps/1024).toFixed(2));
		
		$.progressBar.update( dlProgressBarId, {
			speed : (progressData.bps/1024).toFixed(2)+ 'kb/s',
			progressBarPercentage : progressData.progress.toFixed(2)
		});
		
		/*$.downloadRequests.updateProperty(progressData.id, 'progress', progressData.progress.toFixed(2));
		$.downloadRequests.updateProperty(progressData.id, 'speed', (progressData.bps/1024).toFixed(2));
		var data = calculateSummedProgressAndSpeed( );
		$.progressBar.update( dlProgressBarId, {
			speed : data.speed + 'kb/s',
			progressBarPercentage : data.progress
		});*/
	}
	
	/**
	 * Updates property of progress to 100 of finished download and checks if
	 * whole download is finished.
	 */
	function downloadFinishedCallback( packageData )
	{
		adclog("downloadFinishedCallback()");
		
		packageData = packageData[0];
		
		adclog("downloadFinishedCallback() - package id "+packageData.id );
		
		if(packageData.id == 0) // if id==0, all packages finished
		{
			setProgressBarToFull();
			ADC.requestApplicationClose();
			ADC.close();
			//disable the unpack animation before UI is closed(otherwise CPU will be used on WebViewCoreThread even after calling Deinit())
			if (isUnpackPopupAllowed)
                $("div[id^=fountainG]").removeClass("fountainG");
		}
		else // some package
		{
			packagesDownloaded = packagesDownloaded+1;
			if (isProcessingScreen)
				var title = adcStrings[lang].PROCESSING;
			else
				var title = adcStrings[lang].DOWNLOADING;
			var active = 0;
			for(var p in $.downloadRequests.getAllInfo())
			{
				active++;
			}
			//title = title +" ["+packagesDownloaded+"/"+active+"]";
				
			if(!isCancelDialog) $("#dialog").dialog( "option", "title", title);
			$.downloadRequests.updateProperty(packageData.id, 'progress', 100);
			
			// if new ui/ reload
			if( packageData.name == "AdcUI" || packageData.name == "adcui")
			{
				ADC.reloadUI();
			}
		}
	}
	
	/**
	 * Updates arrays that contain info about requests to be downloaded
	 * and their info. After that launches flow.
	 */
	function getUpdatesCallback( packages )
	{
		adclog("getUpdatesCallback()");
		
		if($.downloadRequests.checkIfNewRequests(packages))
		{	
			adclog("getUpdatesCallback() - NEW requests found");
			var updatedPackages = $.downloadRequests.updateMany( packages );
			$.downloadRequests.updateInfoMany( updatedPackages );
			var allRequests = $.downloadRequests.getAllRequests();
			assetsFlow( allRequests );
		}
		else
			adclog("getUpdatesCallback() - NO new requests found");
	}
	
	/**
	 * Adds requests to array that should contain info about elements that
	 * should be downloaded and launches updates to get more specific info
	 * about this requests
	 */
	function downloadRequestCallback( packages )
	{
		adclog("downloadRequestCallback()");
		
		isProgressPopupAllowed = false;
		$.downloadRequests.addMany( packages );
		ADC.getPackages();
	}
	
	/**
	 * Checks which requests form update queue are being downloaded and 
	 * adds this requests info to array with infos about requests
	 */
	function getQueueCallback( packagesData )
	{
		adclog("getQueueCallback() - package data length " + packagesData.length);
		
		downloadedPackages.lenght = 0;
		var activeDownloads = 0;
		
		for( var i in packagesData )
		{
			adclog("getQueueCallback() - name "+packagesData[i].name+" status "+packagesData[i].status );
			if( packagesData[i].status != 6 ) //if not completed yet
			{
				downloadedPackages.push( packagesData[i] );
				activeDownloads++;
			}
		}
		$.downloadRequests.updateInfoMany( downloadedPackages );
		
		packagesDownloaded = 0;
		var title = adcStrings[lang].DOWNLOADING;
		//title = title +" ["+packagesDownloaded+"/"+activeDownloads+"]";
		if(!isCancelDialog) $("#dialog").dialog( "option", "title", title);
		
		if(isQueueRetrieved == false)
		{
			isQueueRetrieved = true;
			checkConnection(function(){
					if( activeDownloads == 0)
					{
						adclog("getQueueCallback() - no activeDownloads");
						//wait for close	
						autoCloseTimer = setTimeout( function(){ ADC.close()}, 2000);
					}
					else
					{
						if (isUnpackPopupAllowed)
						{
							adclog("getQueueCallback() - isUnpackPopupAllowed true");
							doPopupWithLoader();
						}
						else
						{
							adclog("getQueueCallback() - isUnpackPopupAllowed false");
							for( var i in downloadedPackages )
							{								
								if (downloadedPackages[i].status == 5)
								{									
									ADC.resumeDownload(downloadedPackages[i].id);							
								}
							}
							doPopupWithProgressBar();														
						}
						if(autoCloseTimer!=null)
						{
							clearInterval(autoCloseTimer);
							autoCloseTimer = null;
						}
					}
			});
		}
		else if( activeDownloads == 0)
		{
			ADC.close();
		}
	}
	
	/**
	 * Sets progressBar gauge to full
	 * 
	 * TODO: Move it to progressBar singleton
	 */
	function setProgressBarToFull()
	{
		adclog("setProgressBarToFull()");
		
		$.progressBar.update( dlProgressBarId, {
			speed : '0kb/s',
			progressBarPercentage : 100
		});
	}
	
	function doCancelDialog(beforeConfirmation)
	{
		adclog("doCancelDialog()"+beforeConfirmation);

		isCancelDialog = true;
		var cancelTitle = adcStrings[lang].CANCEL;
		var cancelMessage = adcStrings[lang].CONFIRM_CANCEL;
		var cancelYesButton = adcStrings[lang].YES;
		var cancelNoButton = adcStrings[lang].NO;
		var allInfo = $.downloadRequests.getAllInfo();
		doPopup(cancelTitle, cancelMessage, [
			{ text: cancelYesButton, callback: function () {
			    isCancelDialog = false;
			    ADC.stopAllDownloads();
			    setTimeout(function () {
			        ADC.close();
			    }, 250);
			}
			},
			{ text: cancelNoButton, callback: function () {			 
			    closeCancelDialog(beforeConfirmation);
			}
			}
		]);
    }

    function closeCancelDialog(beforeConfirmation) 
    {
        isCancelDialog = false;
		adclog("closeCancelDialog() showOtherPopUp "+showOtherPopUp);
        if (showOtherPopUp > 1) 
        {
			adclog("closeCancelDialog() "+savedTitle+" "+savedMessage);
            doPopup(savedTitle, savedMessage, savedButtons);

            showOtherPopUp = 0;
            savedTitle = "";
            savedMessage = "";
            savedButtons = "";
            return;
        }
		
		showOtherPopUp = 0;
		savedTitle = "";
		savedMessage = "";
		savedButtons = "";
			
        if (isUnpackPopupAllowed) 
        {
            doPopupWithLoader();
        }
        else 
        {
            if (beforeConfirmation == false) 
            {
                if (ADC.is3gAllowed() == true)
                    doPopupWithProgressBar(true);
                else
                    checkConnection(doPopupWithProgressBar);
            }
            else 
            {
                checkConnection(doInitPopup);
                downloadRequestCallback(downloadRequest);
            }
        }
    }

	
	/**
	 * Opens dialog with progressBar
	 *
	 * @param setToFull bool tells if popup should be set to full after opening
	 */
	function doPopupWithProgressBar( setToFull )
	{
		adclog("doPopupWithProgressBar()");
		
		if( !isProgressPopupAllowed )
		{
			if(isUnpackPopupAllowed)
			{
				doPopupWithLoader();
			}
			return;
		}
		adclog("doPopupWithProgressBar() - getting total progress");
		ADC.getTotalProgress();		
		var title = adcStrings[lang].DOWNLOADING;
		

		var active = 0;
		for(var p in $.downloadRequests.getAllInfo())
		{
			active++;
		}
		//title = title +" ["+packagesDownloaded+"/"+active+"]";
		
		var buttonText = adcStrings[lang].CANCEL;
		
		$.progressBar.remove( dlProgressBarId );
		var message = $.progressBar.create( dlProgressBarId );
		
		doPopup(title, message, [
			{ text: buttonText, callback: function(){
				adclog("doPopupWithProgressBar() -doCancelDialog");
				doCancelDialog(false);
			} }
		]);
		if( setToFull )
			setProgressBarToFull();
		else
		{
			$.progressBar.update( dlProgressBarId, {
				speed : '0kb/s',
				progressBarPercentage : currentProgress
			});
		}
	}
	
	/**
	 * Opens a dialog with a loading circle. 
	 *
	 * Displays a visual feedback to the user while Mercury unpacks the downloaded packages.
	 */
	function doPopupWithLoader()
	{
		adclog("doPopupWithLoader()");
		
		var title = adcStrings[lang].UNPACKING;
		var buttonText = adcStrings[lang].CANCEL;
		var message = '<table width="100%"><tr><td align="right" width="50%">'+adcStrings[lang].WAIT+'</td><td align="left" width="50%"><div id="fountainG"><div id="fountainG_1" class="fountainG"></div><div id="fountainG_2" class="fountainG"></div><div id="fountainG_3" class="fountainG"></div><div id="fountainG_4" class="fountainG"></div><div id="fountainG_5" class="fountainG"></div><div id="fountainG_6" class="fountainG"></div><div id="fountainG_7" class="fountainG"></div><div id="fountainG_8" class="fountainG"></div></div></td></tr></table>';
		doPopup(title, message, [
			{ text: buttonText, callback: function(){
				adclog("doPopupWithLoader() doCancelDialog");
				doCancelDialog(false);
			} }
		]);
	}
	
	/**
	 * Opens processing screen. 
	 *
	 * Displays a visual feedback to the user while Mercury unpacks the downloaded packages.
	 */
	function doProcessingScreen()
	{
		adclog("doProcessingScreen()");
				
		var title = adcStrings[lang].PROCESSING;
		var buttonText = adcStrings[lang].CANCEL;
		var processingMessage = String(ADC.getProcessingText());
		if (!processingMessage || 0 == processingMessage.length || "" == processingMessage)
		    processingMessage = adcStrings[lang].WAIT;

		var message = '<table width="100%"><tr><td align="right" width="50%">' + processingMessage + '</td><td align="left" width="50%"><div id="fountainG"><div id="fountainG_1" class="fountainG"></div><div id="fountainG_2" class="fountainG"></div><div id="fountainG_3" class="fountainG"></div><div id="fountainG_4" class="fountainG"></div><div id="fountainG_5" class="fountainG"></div><div id="fountainG_6" class="fountainG"></div><div id="fountainG_7" class="fountainG"></div><div id="fountainG_8" class="fountainG"></div></div></td></tr></table>';
		doPopup(title, message, [
			{ text: buttonText, callback: function(){
				adclog("doPopupWithLoader() doCancelDialog");
				doCancelDialog(false);
			} }
		]);
	}
	
	/**
	 * Opens dialog
	 * 
	 * @param title string popup title inside header
	 * @param message string text inside popup
	 * @param buttons array array of objects with 'text' and 'callback' properties
	 * 
	 * @example doPopup('Dialog Title', 'This is message inside dialog', [ { text : 'OK', callback : function(){ alert(OK); } } ]);
	 */
	function doPopup(title, message, buttons)
	{
		adclog("doPopup()");
		doPopupNumber++;
		if (isCancelDialog) 
        {
			adclog("doPopup() isCancelDialog true");
            showOtherPopUp++;
			adclog("doPopup() showOtherPopUp "+showOtherPopUp);
            if (showOtherPopUp > 1) 
            {
				adclog("doPopup() replacing saved values "+savedTitle+" "+savedMessage+" with new values "+title+" "+message);
                savedTitle = title;
                savedMessage = message;
                savedButtons = buttons;
				adclog("doPopup() finished");
                return;
            }
		}

		/* checking if dialog was created before and removing it to avoid memory leak */
		if($('#dialog').is(':data(dialog)'))
		{	
			$( "#dialog" ).dialog('destroy');
		}

		/* creating buttons with callbacks on click */
		var buttonsCollection = {};
		for( var buttonIndex in buttons )
		{
			var buttonText = buttons[buttonIndex].text,
			buttonCallback = buttons[buttonIndex].callback || function(){};
			buttonsCollection[buttonText] = (function(value, btnCallback) {
				return function() {
					
					$( this ).dialog( "close" );
					btnCallback.call(this, value);
				}
			})(buttonIndex, buttonCallback);
        }
		
		// get the larger value between width and height - we always show in landscape but it may start in portrait(this means that $(window).width() may be in fact $(window).height() )
        screenWidth = (($(window).width() > $(window).height()) ? $(window).width() : $(window).height());

        adclog("doPopup() Window size -> width " + $(window).width() + " height " + $(window).height());

		/* creating dialog */
		$( "#dialog" ).attr('title', title);
		$( "#dialog" ).html( message );
		$( "#dialog" ).dialog({
		    width: screenWidth * 0.75,
			resizable : false,
			draggable : false,
			closeOnEscape: false,
			beforeClose : function()
			{
				
			},
			open: function(event, ui) { 
				$(".ui-dialog-titlebar-close").hide(); 				
			},
			buttons : buttonsCollection
		});

		/* updating button's position based on amount of buttons */
		buttons = buttons || [];
		var buttonsSize = buttons.length;
		if( buttonsSize >= 2 )
		{
			$('.ui-dialog-buttonset>button:first-child').css('float','left');
			$('.ui-dialog-buttonset>button:first-child').css('margin-right', '0px');
			$('.ui-dialog-buttonset>button:last-child').css('float','right');
			$('.ui-dialog-buttonset>button:last-child').css('margin-right', '0px');
		}
	}
	
	function doInitPopup()
	{
		adclog("doInitPopup()");
		
		title = adcStrings[lang].WAIT;
		message =  adcStrings[lang].UPDATING;
		doPopup(title, message);
		isInitialized = true;
	}
	
	/**
	 * ProgressBar singleton
	 */
	$.progressBar = {
		/**
		 * Creates progressBar and progressBar wrapper html code 
		 * if it not already exists
		 * 
		 * @param progressBarId string unique element id
		 */
		create : function( progressBarId )
		{			
		adclog("progressBar.create() - Creating progressbar.");
			var progressBar = this.getProgressBar( progressBarId );
			var html = '';
			if( progressBar && progressBar.length == 0 )
			{
				html = ''
				+ '<div id="group-' + progressBarId + '">'
					+ '<div class="group-header">' + connectionTypeMsg + '</div>'
					+ '<div id="' + progressBarId + '"></div>'
					+ '<div class="group-footer">'
						+ '<div class="percentage">'+currentProgress+'%</div><div class="speed">0kb/s</div><div class="cleaner"></div>'
					+ '</div>'
				+'</div>'
			}
			return html;
		},
		/**
		 * Removes progressBar wrapper html code with all his elements
		 * 
		 * @param progressBarId string unique element id
		 */
		remove : function( progressBarId )
		{
			var progressBar = this.getProgressBar(progressBarId);
			if (progressBar && progressBar.progressbar) {
				progressBar.progressbar('destroy');
				$( '#group-' + progressBarId ).remove();
			}
		},
		/**
		 * Gets progressBar with specified id
		 * 
		 * @param progressBarId string unique element id
		 * @return progressBar element or empty array if not found
		 */
		getProgressBar : function( progressBarId )
		{
			return $('#' + progressBarId);
		},
		/**
		 * Gets tag where speed value is updated
		 * 
		 * @param progressBarId string unique element id
		 * @return speed element or empty array if not found
		 */
		getSpeed : function( progressBarId )
		{
			return $( '#group-' + progressBarId + ' .group-footer .speed' );
		},
		/**
		 * Gets tag where percentage value is updated
		 * 
		 * @param progressBarId string unique element id
		 * @return percentage element or empty array if not found
		 */
		getPercentage : function( progressBarId )
		{
			return $( '#group-' + progressBarId + ' .group-footer .percentage' );
		},
		/**
		 * Updates progressBar, speed and prectentage element to specified value
		 * 
		 * @param progressBarId string unique element id
		 * @param newData object with progressBarPercentage and speed properties
		 */
		update : function( progressBarId, newData )
		{
			if( $( '#group-' + progressBarId ) )
			{
				this.getProgressBar(progressBarId).progressbar({
					value: parseInt(newData.progressBarPercentage)
				});
				this.getPercentage(progressBarId).html(newData.progressBarPercentage + '%');
				this.getSpeed(progressBarId).html(newData.speed);
			}
		},
		/**
		 * Checks if progressBar was already created
		 * 
		 * @param progressBarId string progressBarId string unique element id
		 * @return true if is already created otherwise false
		 */
		checkIfExists : function( progressBarId )
		{
			var progressBar = this.getProgressBar( progressBarId );
			if( progressBar && progressBar.is(':data(progressbar)') )
				return true;
			else
				return false;
		}
	}
	
	/**
	 * Initializes UI
	 *
	 * Sets language properties and shows dialog with progressBar
	 */
	function initGui()
	{
		adclog("initGui()");
		
		if( adcStrings[locale] == null )
		{
			if( adcStrings[lang] == null )
			{
				lang = "en";
			}
		}
		else
		{
			lang = locale;
		}
		isUnpackPopupAllowed = ADC.isUnpacking();
		doInitPopup();
	}
	
	
	function continueIn3G(isConnectedCallback)
	{
		adclog("continueIn3G()");
		
		if( ADC.isConnected() )
		{
			connectionTypeMsg = adcStrings[lang].DOWNLOADING_OVER_WIFI;
			if( ADC.is3G())
			{
				title = adcStrings[lang].CONFIRM;
				if(ADC.is4G())
                {
                    message =  adcStrings[lang].CONTINUE_WITH_4G;
                }
                else
                {
				    message =  adcStrings[lang].CONTINUE_WITH_3G;
                }
				buttonText = adcStrings[lang].YES,
				buttonText2 = adcStrings[lang].NO;

				doPopup(title, message, [
					{ text: buttonText, callback : function( ){
						//using3g = true;
						ADC.set3gAllowed(true);
						ADC.setEnable(true);
						if (ADC.is4G()) {
						    connectionTypeMsg = adcStrings[lang].DOWNLOADING_OVER_4G;
						}
						else {
						    connectionTypeMsg = adcStrings[lang].DOWNLOADING_OVER_3G;
						}
						
						if( isConnectedCallback && typeof isConnectedCallback === 'function' )
						isConnectedCallback();
					} },
					{ text: buttonText2, callback : function( ){
						ADC.close();
						ADC.onCancelUI(false);
					} }
				
				]);
			}
			else
			{
				is3g = false;
				inCheckConnection = false;
				if( isConnectedCallback && typeof isConnectedCallback === 'function' )
					isConnectedCallback();
			}
		}
		else
		{
			title = adcStrings[lang].NO_INTERNET_CONNECTION,
			message =  adcStrings[lang].NO_INTERNET_CONNECTION_MSG,
			buttonText = adcStrings[lang].WIFI,
			buttonText2 = adcStrings[lang].CANCEL;
			is3g = false;
			
			doPopup(title, message, [
				{ text: buttonText, callback : function( ){
					ADC.runConnectionManagment();				
				}},
				{ text: buttonText2, callback : function( ){
					ADC.stopAllDownloads();
					setTimeout(function(){
						ADC.close();
						ADC.onCancelUI(false);
					}, 250);
				} 
				}]);
		}
	}
	/**
	 * Checks connection
	 * 
	 * @param isConnectedCallback function optional callback function if connection is found  
	 */
	function checkConnection( isConnectedCallback )
	{
		inCheckConnection = true;
		adclog( "checkConnection()");
		
		if(ADC.isConnected())
		{
			if(ADC.is3G() == true)
			{
				if (ADC.is3gAllowed() == true)
				{
					adclog( "checkConnection() - ADC.is3G() == true && ADC.is3gAllowed() == true");
					inCheckConnection = false;
					isConnectedCallback();
					return;
				}
				else
				{
					ADC.set3gAllowed( false);
				}	
					continueIn3G(isConnectedCallback);
			}
			else
			{
				connectionTypeMsg = adcStrings[lang].DOWNLOADING_OVER_WIFI;
				ADC.set3gAllowed( false);
				inCheckConnection = false;
				if( isConnectedCallback && typeof isConnectedCallback === 'function' )
					isConnectedCallback();			
			}
		}
		else
		{
			title = adcStrings[lang].NO_INTERNET_CONNECTION,
			message =  adcStrings[lang].NO_INTERNET_CONNECTION_MSG,
			buttonText = adcStrings[lang].WIFI,
			buttonText2 = adcStrings[lang].CANCEL;
			is3g = false;
			
			doPopup(title, message, [
				{ text: buttonText, callback : function( ){
					ADC.runConnectionManagment();				
				}},
				{ text: buttonText2, callback : function( ){
					ADC.stopAllDownloads();
					setTimeout(function(){
						ADC.close();
						ADC.onCancelUI(false);
					}, 250);
				} 
				}]);
		}
	}

